struc xmpp_stream {
	.from	 db 255 dup (0)   ; from string pointer
	.to	 db 255 dup (0)   ; to string pointer
	.version db '1.0',0	  ; version
	.lang	 db 'en',0	  ; language
	.ns	 db 'jabber:client',0 ; xml namespace
	.nsstr	 db 'http://etherx.jabber.org/streams',0 ; stream namespace
	.id	 db 256 dup (0)   ; id (reserved)
}

virtual at 0
	vstream xmpp_stream
end virtual

macro construct_stream stream,p_from,p_to {
	lea	eax, [stream]
	add	eax, vstream.from
	stdcall strcpy,p_from,eax
	add	eax, vstream.to
	stdcall strcpy,p_to,eax
}

macro pushStreamStruc stream {
	; End tag
	push	0
	; From
	mov	eax,stream+vstream.from
	push	eax
	push	xc_from
	; To
	mov	eax,stream+vstream.to
	push	eax
	push	xc_to
	; Version
	mov	eax,stream+vstream.version
	push	eax
	push	xc_version
	; Lang
	mov	eax,stream+vstream.lang
	push	eax
	push	xc_lang
	; Namespace
	mov	eax,stream+vstream.ns
	push	eax
	push	xc_ns
	; Ns:stream
	mov	eax,stream+vstream.nsstr
	push	eax
	push	xc_nsstr

}