;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Constants
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
login_win_X	equ 900
login_win_Y	equ 450

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Draw main window
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
proc login_win_draw
	; Start redraw
	mcall	12, 1
	; Get sys colours into sys_colours var
	call	get_sys_colours
	; fn 0 - define and draw window
	mov	eax, 0
	; fn 0.ebx - win X dims = start * 65536 + x_size
	mov	ebx, 100 * 65535 + login_win_X
	; fn 0.ecx - win Y dims = start * 65536 + y_size
	mov	ecx, 100 * 65535 + login_win_Y
	; fn 0.edx - window colour and type (type 14 - fixed size with title)
	mov	edx, [w_work]
	or	edx, 0x14000000
	; fn 0.esi - window title style and colour
	mov	esi, [w_grab]
	or	esi, 0x80000000
	mcall
	; Draw login box
	push	dword login_box
	call	[edit_box_draw]
	; Draw pass box
	push	dword pass_box
	call	[edit_box_draw]
	; Draw server box
	push	dword serv_box
	call	[edit_box_draw]
	; Draw DEBUG BOX
	push	dword dbg_box
	call	[edit_box_draw]
	; Draw ok btn
	call	login_ok_btn_draw
	; End redraw
	mcall	12,2
	; Return
	ret
endp

proc login_ok_btn_draw
	; push regs
	pusha
	; fn 8 - draw btn
	mov	eax, 8
	; fn 8.ebx, 8.ecx - position*65536 + size
	mov	ebx, 20*65536 + 50
	mov	ecx, 100*65536 + 20
	; fn 8.edx - flags + id (id = 2)
	mov	edx, 0x00000002
	; fn 8.esi - color
	mov	esi, 0x00555555
	mcall
	; restore regs
	popa
	;return
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; BOXES
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
eb_width	equ 150
eb_left 	equ 5
eb_bg		equ 0xffffff
eb_shift	equ 0x6f9480
eb_focus	equ 0
eb_blur 	equ 0xAABBCC
eb_text_col	equ 0
eb_tmax 	equ 45
;-----------------------------------
login_top	equ 25
login_text	db 'test@192.168.42.54',0
login_end:
	rb 256
login_box	edit_box	eb_width, eb_left, login_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				login_text, 0, ed_focus,\	; text, mouse_var, flags
				login_end - login_text - 1,\	; size
				login_end - login_text - 1	; pos
;-----------------------------------
pass_top	equ 50
pass_text	db 'test',0
pass_end:
	rb 256
pass_box	edit_box	eb_width, eb_left, pass_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				pass_text, 0, ed_pass,\ 	; text, mouse_var, flags
				pass_end - pass_text - 1,\	; size
				pass_end - pass_text - 1	; pos
;-----------------------------------
serv_top	equ 75
serv_text	db '192.168.42.54',0
serv_end:
	rb 256
serv_box	edit_box	eb_width, eb_left, serv_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				serv_text, 0, 0,\		; text, mouse_var, flags
				serv_end - serv_text - 1,\	; size
				serv_end - serv_text - 1	; pos

